import { Ref, RefTypes } from './ref';
export interface IRegistry<K extends string, T extends object> {
    queue(item: T): Ref<K>;
    numUnprocessed(): number;
    drain(cb: (ref: Ref<K>, item: T) => void): {
        processedCount: number;
    };
    drainUntilEmpty(cb: (ref: Ref<K>, item: T) => void): {
        processedCount: number;
    };
}
export declare function createQueue<K extends RefTypes, T extends object>(k: K, idGenerator: (t: T) => string): IRegistry<K, T>;
//# sourceMappingURL=queue.d.ts.map